/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#include "ZGradient.h"
#include "ZColor.h"

///
ZGradient::ZGradient()
{
	{for(sint32 c=0;c<GRADIENTSLOTS;c++)
	{
		col[c]= 0;
		pos[c]=-1;
	}}
	{for(sint32 c=0;c<=GRADIENTMAXINTPOS;c++)
	{
		pre[c]=0;
	}}
}

///
void ZGradient::SetColor(uint32 color, sint32 slot, float32 position)
{
	if(slot>=0 && slot<GRADIENTSLOTS)
	{
		col[slot]=color;
		pos[slot]=position;
		Update();
	}
}

///
uint32 ZGradient::GetColor(sint32 pos) const
{
	return pre[ZMIN(GRADIENTMAXINTPOS,ZMAX(0,pos))];
}

void ZGradient::Update()
{
	if(pos[0]>=0)
	{
		if(pos[0]>0)
		{
			sint32 end   = (sint32)(pos[0]*(GRADIENTMAXINTPOS));
			for(sint32 i=0;i<=end;i++)
			{
				pre[i] = col[0];
			}
		}
		for(sint32 c=0;c<GRADIENTSLOTS;c++)
		{
			if(pos[c]>=0)
			{
				if(pos[c+1]>=0)
				{
					sint32 start = (sint32)(pos[c+0]*(GRADIENTMAXINTPOS));
					sint32 end   = (sint32)(pos[c+1]*(GRADIENTMAXINTPOS));
					sint32 diff  = end-start;

					for(sint32 i=start;i<=end;i++)
					{
						pre[i] = ZColor::Interpolate(col[c+0],col[c+1],(uint08)(((i-start)*255)/diff));
					}
				}
				else
				{
					sint32 start = (sint32)(pos[c+0]*(GRADIENTMAXINTPOS));
					for(sint32 i=start;i<=GRADIENTMAXINTPOS;i++)
					{
						pre[i] = col[c];
					}
				}
			}
		}
	}
}