/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#ifndef _ZGRADIENT_H_
#define _ZGRADIENT_H_
#include "ZSystem.h"

/// Implements a color gradient
class ZGradient
{
	public:

		enum
		{
			GRADIENTBUFFERBITS	= 10,
			GRADIENTBUFFERSIZE	= 1024,
			GRADIENTMAXINTPOS	= 1023,
			GRADIENTSLOTS		= 8
		};

						///
					ZGradient();
						///
	virtual			~ZGradient() {}

						///
			void	SetColor(uint32 color, sint32 slot, float32 position);
						///
			uint32	GetColor(sint32 pos) const;

	private:

			void	Update();

			uint32	pre[GRADIENTBUFFERSIZE];
			uint32	col[GRADIENTSLOTS];
			float32	pos[GRADIENTSLOTS];
};

#endif