/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#ifndef _ZLINE_H_
#define _ZLINE_H_

#include "ZMatrix.h"

/// Represents a line in 2D space
class ZLine
{
	public:
	
			ZPoint	 P0;
			ZPoint	 P1;
					
						///
					 ZLine();
						///
					 ZLine(ZPoint p0, ZPoint p1);
					 	///
					~ZLine();
					
						///
		void		 Set(ZPoint p0, ZPoint p1);
				
						/// returns true if lines intersect	
		bool		 Intersects(const ZLine &from) const;
						/// returns true if lines intersect and sets intersection point	
		ZPoint		 Intersection(const ZLine &from) const;
						/// true when point is ccw orientied from this line, false when cw
		float32		 Orientation(const ZPoint &from) const;
						/// returns center of line
		ZPoint		 Center() const;
						/// returns length of line
		float32		 Length() const;
						/// returns head line of this line
		ZLine		 Head(float32 length) const;
						/// returns tail line of this line
		ZLine		 Tail(float32 length) const;

};

#endif