/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#ifndef _ZMATRIX_H_
#define _ZMATRIX_H_

class ZMatrix;

#include "ZPoint.h"

/// 2D transformation matrix data structure
class ZMatrix
{
	public:
						 ZMatrix();

				void	 SetRotation(float32 angle);
				void	 SetScaling(ZPoint factor);
				void	 SetTranslation(ZPoint vector);
				void	 SetSkewing(ZPoint angles);
				
				float32	 Rotation() const { return _rotate; }
				ZPoint	 Scaling() const { return _scale; }
				ZPoint	 Translation() const { return _translate; }
				ZPoint	 Skewing() const { return _skewing; }

				ZPoint	 operator*(const ZPoint &from) const;
				ZMatrix	 operator*(const ZMatrix &from) const;
				ZMatrix	 &operator*=(const ZMatrix &from);
				ZMatrix	 &operator=(const ZMatrix &from);
				
				void	 MakeIdentity();
							///
				float32	 Determinant();
				void	 Inverse();

				float32	 mtx[9];

	private:

				void	 Update();
				
				ZPoint	_skewing;
				ZPoint	_scale;
				float32	_rotate;
				ZPoint	_translate;
}///
;

#endif
