/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#include "ZOutliner.h"
#include "ZLine.h"
#include <assert.h>

// This code is plain ugly and work in progess
// Its a quick hack to test out various stroke
// algorithms

class ZReverse : public ZPath::Iterator
{
	public:
						 ZReverse() { }

				ZPath	 &Go(const ZPath &from)
						 {
							path.MakeEmpty();
							from.Iterate(this);
							return path;
						 }

		virtual	void	 Init() 
						 {
 							idx=0;
						 }

		virtual	void	 MoveTo(ZPoint point) 
						 {
							if(idx<2048)
								lines[idx++] = start = point; 
						 }

		virtual	void	 LineTo(ZPoint point) 
						 {
							if(idx<2048)
								lines[idx++] = point; 
						 }

		virtual	void	 Close() 
						 {
							if(idx<2048)
								lines[idx++] = start; 

							path.AddMoveTo(lines[idx-1]);
							for(sint32 c=idx-2;c>=0;c--)
								path.AddLineTo(lines[c]);
							path.AddClose();

							idx=0;
						 }

		virtual	void	 CurveTo(ZPoint control, ZPoint point) { }
		virtual	void	 CurveTo(ZPoint control1, ZPoint control2, ZPoint point) { }
		virtual	void	 ArcTo(ZPoint radius, ZPoint point, float32 rotation = 0, sint32 sweep = 1) { }

	private:

				ZPath	 path;
				ZPoint	 start;
				sint32	 idx;
				ZPoint	 lines[2048];
};

///
ZOutliner::ZOutliner()
{
	reverser = new ZReverse();
}

///
ZOutliner::~ZOutliner()
{
	delete reverser;
}

///
ZPath &ZOutliner::ComputeOutline(const ZPath &from, float32 radius)
{
	init = false;
	rad = radius;
	innpath.MakeEmpty();
	outpath.MakeEmpty();
	from.Iterate(this);
	outpath+=reverser->Go(innpath);
	return outpath;
}

///
void ZOutliner::MoveTo(ZPoint point)
{
	init = true;
	ZSketcher::MoveTo(point);
}

static ZLine strhead;
static ZLine strtail;
static ZLine oldhead;
static ZLine oldtail;

///
void ZOutliner::LineTo(ZPoint point)
{
	if(point != CurrentPoint())
	{
		ZLine curr(CurrentPoint(),point);
		ZLine head(curr.Head(rad));
		ZLine tail(curr.Tail(rad));
		if(init)
		{
			innpath.AddMoveTo(head.P0);
			innpath.AddLineTo(tail.P0);
			outpath.AddMoveTo(head.P1);
			outpath.AddLineTo(tail.P1);
			init = false;
			strhead = oldhead = head;
			strtail = oldtail = tail;
		}
		else
		{
			innpath.AddLineTo(ZLine(oldhead.P0,oldtail.P0).Intersection(ZLine(head.P0,tail.P0)));
			outpath.AddLineTo(ZLine(oldhead.P1,oldtail.P1).Intersection(ZLine(head.P1,tail.P1)));
			innpath.AddLineTo(head.P0);
			innpath.AddLineTo(tail.P0);
			outpath.AddLineTo(head.P1);
			outpath.AddLineTo(tail.P1);
			oldhead = head;
			oldtail = tail;
		}
	}
	ZSketcher::LineTo(point);
}

///
void ZOutliner::Close()
{
	ZSketcher::Close();
	innpath.AddLineTo(ZLine(oldhead.P0,oldtail.P0).Intersection(ZLine(strhead.P0,strtail.P0)));
	outpath.AddLineTo(ZLine(oldhead.P1,oldtail.P1).Intersection(ZLine(strhead.P1,strtail.P1)));
	innpath.AddClose();
	outpath.AddClose();
}
