/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#ifndef _ZSKETCHER_H_
#define _ZSKETCHER_H_

#include "ZPath.h"

/// splits curves&arc into simple lines
class ZSketcher : public ZPath::Iterator
{
	public:
						  ZSketcher():_strt(false) {}
		virtual			 ~ZSketcher() {}

	protected:

							/// Returns current cursor position
		ZPoint			  CurrentPoint() { return _curr_point; }
							/// Returns starting cursor position
		ZPoint			  StartPoint() { return _strt_point; }

		virtual	void	  Init();
		virtual	void	  MoveTo(ZPoint point);
		virtual	void	  LineTo(ZPoint point);
		virtual	void	  CurveTo(ZPoint control, ZPoint point);
		virtual	void	  CurveTo(ZPoint control1, ZPoint control2, ZPoint point);
		virtual	void	  ArcTo(ZPoint radius, ZPoint point, float32 rotation = 0, sint32 sweep_arc = 1);
		virtual	void	  Close();
		
	private:
	
		ZPoint			 _strt_point;
		ZPoint			 _curr_point;
		bool			 _strt;
};

#endif