/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#include <stdio.h>
#include <string.h>
#include "ZRenderer.h"

unsigned char buffer[800*600*3];
unsigned char screen[800*600*4]; 

void update(void)
{
	unsigned char *p0=screen;
	unsigned char *p1=buffer;

	for(int dd=0;dd<(800*600);dd++)
	{
		p1[0]=p0[0];
		p1[1]=p0[1];
		p1[2]=p0[2];
		p1+=3;
		p0+=4;
	}

	FILE *fd=0;
	if(fd=fopen("/dev/fb0","w"))
	{
		fwrite(buffer,sizeof(buffer),1,fd);
		fseek(fd,0,SEEK_SET);
		fclose(fd);
	}
}

int main()
{
	ZRenderer renderer;

	sint32 cur=-1,cnt=0;
	ZColorStencil *stncs[64];
	ZPath *paths[64][64];
	memset(stncs,0,sizeof(stncs));
	memset(paths,0,sizeof(paths));

	printf("Reading file...\n");

	{FILE *fp = fopen("lion.txt","r");
	if(fp)
	{
		char line[1024];
		for(;!feof(fp);)
		{
			fgets(line,1024,fp);
			if(line[0]!='M')
			{
				cur++;
				cnt=0;
				uint32 color = 0;
				sscanf(line,"%x",&color);
				color|=0xFF000000;
				stncs[cur] = new ZColorStencil(color);
			}
			else
			{
				paths[cur][cnt] = new ZPath();
				ZPath path;
				sint32 x,y;
				char *scan = line;
				for(;sscanf(scan+1," %d,%d ",&x,&y);)
				{
					if(*scan=='M')
					{
						paths[cur][cnt]->AddMoveTo(ZPoint(x,y)-ZPoint(120,180));
					}
					else
					{
						paths[cur][cnt]->AddLineTo(ZPoint(x,y)-ZPoint(120,180));
					}
					if(*scan == 0) break;
					for(scan++;*scan!='L';scan++) 
					{
						if(*scan == 0) break;
					}
				}
				paths[cur][cnt]->AddClose();
				cnt++;
			}
		}
		fclose(fp);
	}}
	
	ZMatrix matrix;

	printf("Starting drawing...\n");

	for(;;)
	{
		renderer.SetBuffer((uint32 *)screen,(uint32)800,(uint32)600,(uint32)800);
		renderer.ClearBuffer();

		matrix.SetTranslation(ZPoint(260,220));
		{for(sint32 c=63;c>=0;c--)
		{
			for(sint32 i=63;i>=0;i--)
			{
				if(paths[c][i])
				{
					renderer.DrawPath(*paths[c][i],matrix,*stncs[c]);
				}
			}
		}}
	 	renderer.FinalizeBuffer(0xFFFFFF);
		update();
	}
}